# Boilerplate for Vala & GTK 3
Boilerplate for Vala & GTK 3 is a project to make it easy for anyone interested in creating GTK 3 applications in Vala. It comes with all the basic plumbing hooked-up and and easy to follow comments. 

# Features
* Uses Gtk.Application
* Command line argument ready
    * Pre-coded `-debug`, `-version` and `-disable-csd` arguments
* Uses Glade UI files whenever possible
* Toggable Dark mode
* Toggable Client Side Decorations (CSD)
* Settings via Gio.Setting
* Application menu setup for:
    * Preferences
    * Keyboard Shortcuts
    * Help
    * About
    * Quit
* Preferences Window
    * Tab seperated options
    * Global settings search
    * Linked to Gio.Settings
    * Few examples of the type of options you can easily add
* Keyboard Shortcuts Window
    * Simple Glade ui file
* Help Window
* About Window
    * Credits are connected to makefile (!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!)
* Translation ready
* `automake` & `meson` files
    * Flatpak support
* `.gschema.xml` file
* `.desktop` file
* `.appdata.xml` file
* Example icons

## Dependencies
Fedora:

    # dnf groupinstall "C Development Tools and Libraries"
    # dnf install valac gtk+-devel

Debian/Ubuntu:

    # apt-get install build-essential
    # apt-get install valac libgtk3-dev

## Build
Running just `make` will install a copy of the entire program in `./build/`:

    $ make

## Run

    $ ./build/bin/boilerplate-for-vala-gtk3

## Install
    # make install